using System;
using System.Text;
using FlowGroup.Crypto;

namespace Scurvy.Crypto
{
    public class UnlockCodeProvider
    {
        private string gamerTag;
        private string developerSecret;

        public UnlockCodeProvider(string developerSecret, string gamerTag)
        {
            this.developerSecret = developerSecret;
            this.gamerTag = gamerTag;
        }

        public string ComputeCode(string userSecret)
        {
            return HashString(userSecret + this.developerSecret + this.gamerTag);
        }

        public bool Validate(string userSecret, string codeToValidate)
        {
            string localHash = ComputeCode(userSecret);
            return codeToValidate.Equals(localHash, StringComparison.InvariantCultureIgnoreCase);
        }


        /// <summary>
        /// Generates a hash of the provided string using the MD5 crypto
        /// </summary>
        private string HashString(string str)
        {
            Encoding encoding = Encoding.ASCII;
            byte[] stringBuffer = encoding.GetBytes(str);
            MD5 hash = new MD5CryptoServiceProvider();
            byte[] hashResult = hash.ComputeHash(stringBuffer);
            return ByteArrayToHexString(hashResult);
        }


        /// <summary>
        /// Convert a byte array to a hex string
        /// </summary>
        private string ByteArrayToHexString(byte[] barray)
        {
            StringBuilder s = new StringBuilder();
            foreach (byte b in barray)
            {
                s.Append(b.ToString("X2"));
            }
            return s.ToString();
        }
    }
}
