using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;
using Scurvy.Crypto;

namespace UnlockCodes
{
    /// <summary>
    /// This is the main type for your game
    /// </summary>
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;
        SpriteFont font;

        string gamerTag,
            userSecret,
            codeToVerify;

        bool codeValidated;

        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";

            Components.Add(new GamerServicesComponent(this));
            SignedInGamer.SignedIn += new EventHandler<SignedInEventArgs>(SignedInGamer_SignedIn);
            SignedInGamer.SignedOut += new EventHandler<SignedOutEventArgs>(SignedInGamer_SignedOut);
        }

        void SignedInGamer_SignedOut(object sender, SignedOutEventArgs e)
        {
            gamerTag = null;
        }

        void SignedInGamer_SignedIn(object sender, SignedInEventArgs e)
        {
            gamerTag = e.Gamer.Gamertag;
            
        }

        /// <summary>
        /// Allows the game to perform any initialization it needs to before starting to run.
        /// This is where it can query for any required services and load any non-graphic
        /// related content.  Calling base.Initialize will enumerate through any components
        /// and initialize them as well.
        /// </summary>
        protected override void Initialize()
        {
            // TODO: Add your initialization logic here

            base.Initialize();
        }

        /// <summary>
        /// LoadContent will be called once per game and is the place to load
        /// all of your content.
        /// </summary>
        protected override void LoadContent()
        {
            // Create a new SpriteBatch, which can be used to draw textures.
            spriteBatch = new SpriteBatch(GraphicsDevice);

            // TODO: use this.Content to load your game content here
            this.font = this.Content.Load<SpriteFont>("Consolas");
        }

        /// <summary>
        /// UnloadContent will be called once per game and is the place to unload
        /// all content.
        /// </summary>
        protected override void UnloadContent()
        {
            // TODO: Unload any non ContentManager content here
        }

        /// <summary>
        /// Allows the game to run logic such as updating the world,
        /// checking for collisions, gathering input, and playing audio.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Update(GameTime gameTime)
        {
            // Allows the game to exit
            if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed ||
                Keyboard.GetState().IsKeyDown(Keys.Escape))
                this.Exit();

            // TODO: Add your update logic here
            if (gamerTag != null && userSecret == null && !Guide.IsVisible)
            {
                Guide.BeginShowKeyboardInput(PlayerIndex.One, "User Secret", "Provide the Secret you gave on the website", string.Empty, inputCallback, null);
            }
            
            base.Update(gameTime);
        }

        private void inputCallback(IAsyncResult result)
        {
            this.userSecret = Guide.EndShowKeyboardInput(result);
            while (Guide.IsVisible)
            {
                //wait!
            }

            Guide.BeginShowKeyboardInput(PlayerIndex.One, "Code", "Now give me the code that the website gave you.", string.Empty, codeCallback, null);
        }

        private void codeCallback(IAsyncResult result)
        {
            this.codeToVerify = Guide.EndShowKeyboardInput(result);

            string developerSecret = "DavyJonesLocker";

            UnlockCodeProvider provider = new UnlockCodeProvider(developerSecret, this.gamerTag);
            if (provider.Validate(this.userSecret, this.codeToVerify))
            {
                this.codeValidated = true;
            }
        }

        /// <summary>
        /// This is called when the game should draw itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Draw(GameTime gameTime)
        {
            graphics.GraphicsDevice.Clear(Color.CornflowerBlue);

            // TODO: Add your drawing code here
            this.spriteBatch.Begin();

            if (gamerTag == null)
            {
                DrawMessage("Please Sign In");
            }
            else if (this.codeValidated)
            {
                DrawMessage("code successfully validated " + this.gamerTag);
            }
            else
            {
                DrawMessage("incorrect code or secret :-(");
            }


            this.spriteBatch.End();

            base.Draw(gameTime);
        }

        private void DrawMessage(string message)
        {
            this.spriteBatch.DrawString(this.font, message, new Vector2(100, 100), Color.Red);
        }
    }
}
